# 《剑网3》DBM插件

文档最后更新时间：2015年10月17日23:54:58

## 参考资料

 * DBM新手使用说明：http://www.jx3pve.com/thread-9891-1-1.html
 * DBM数据设置教程（图文，玩家编写）：http://www.jx3pve.com/thread-10230-1-1.html

## 前言

如果您只想知道如何导入数据而不想全面的了解插件，就不需要继续往下看了，您只需要点击`头像右键`，`菊花插件集`，`打开DBM面板`，`点击右上角的系统菜单`选择导入网络数据即可，或者您可以查看参考资料中的新手使用说明。

## 简介

《剑网3》DBM插件是基于《剑网3》团队事件监控以及魔兽DBM插件作为参考而开发的一款副本辅助插件，下称为`插件`。

#### 插件主要功能与特点

 * 无须其他插件依赖，仅需安装菊花插件集基础库即可。
 * 模块化设计，所有模块均独立分开工作，可自由删除或关闭不需要的模块。
 * 核心模块与界面毫不相关，当不打开数据设置面板时，界面不占用任何的资源，关闭后将释放所有的资源！
 * 强大的近期事件记录，近期遇到的各种BUFF和技能，甚至NPC，以及NPC的喊话一个都不错过，开荒BOSS绝对利器！
 * 所有数据均根据当前副本来自动加载与抛弃，提高插件性能，非常低的CPU以及内存占用，几乎可以忽略不计！
 * 多项设置可自定义，包括颜色，自定义数据等，可自由更换，可以编辑属于自己习惯的插件，创建各种自定义计时器！
 * 模块化事件API，可自由调用各项模块进行工作，可自由更改DBM数据权利，如果您是插件作者！
 * 在网络中可以分享自己定制的数据供玩家使用！(http://www.j3ui.com)

## 插件设置

插件设置在《菊花插件集》管理。可以在游戏页面`Esc - 插件管理`中打开《菊花插件集》，然后点击`团队副本`中找到`DBM分类`，除了基本的设置外，还可以从此处进入数据设置面板。

`特别注意`

* 所有涉及到界面的，如果不能直接拖动都可以按Shift+U进行拖动位置。
* 您可以尝试给插件的面板增加一个快捷键来打开它。

## 数据介绍

插件的数据分为以下几大类，大类下的数据均拥有自己独立的设置项。

* 增益效果：可以监控`Buff`的获得和消失等情况。
* 减益效果：可以监控`DeBuff`的获得和消失等情况。
* 技能：可以监控`技能`的释放等情况。
* NPC：可以监控`NPC`的战斗、血量变化、内力变化、出现与消失等诸多情况。
* 圈圈：可以给对应的`NPC`或者`DOODAD（交互类物品）`绘制面向圈，可以监控NPC的目标变化。
* 喊话：可以监控对应的`NPC喊话内容`以及`系统提示框`的提示内容。

`特别注意`

* 圈圈数据需要画圈圈插件的支持，其数据界面由DBM界面管理。

----

#### 数据地图分类介绍

插件的数据地图分类，根据团队副本的地图进行分类，即一个副本只调用地图中已存在的数据，其他数据将被暂时抛弃，以提高插件的性能以及数据分类的清晰度，并且插件设有`通用`分类，来实现对某些数据全地图使用的需求。

`特别注意`

* 右键数据可以修改数据的分类，如果按住`Ctrl`点击，即可以复制这个数据到其他分类，来实现单独区分或共用的目的。
* 数据可以按住左键拖拽移动，如果左边树列表中不存在某些地图，可以尝试先右键手动输入地图名称。
* 地图分类中的数据优先级大于通用分类。

----

#### 数据导入导出

插件数据使用`LUA TABLE`形式，导出的数据和插件调用的数据完全相同，导入与导出仅限有高级功能需求的玩家进行操作，一般玩家无须理会。

`特别注意`

* 插件的数据保存模式默认情况下是所有角色通用的，即一个角色改动了数据其他角色均共享，除非您的特殊需求，否则建议共用数据。
* 插件导入导出功能在DBM数据设置面板上，无特殊需求的玩家根本无须理会。
* 插件默认导入和导出的路径为`./interface/JH/DBM/data`

----

#### 快速清空数据

DBM支持快速清空数据，只需要创建导入一个空白的文件即可，文件内容如下。

```lua
data = {
    ["BUFF"]    = {},
    ["DEBUFF"]  = {},
    ["CASTING"] = {},
    ["NPC"]     = {},
    ["TALK"]    = {},
    ["CIRCLE"]  = {},
}
```

----

## 报警通用颜色

部分监控模块会受到报警通用颜色的影响，下面有介绍，如果需要修改可以点击数据设置面板上的图标进行修改。

----

## 监控通用设置

监控通用设置中的项目均会影响数据是否会触发。

 * 监控对象列表，顾名思义，自己、团队（包含自己），敌对。
 * 自身心法要求，顾名思义对应心法才触发监控，支持多选，全部不勾选即代表对心法没有要求。
 * 层数需求/数量需求，BUFF的层数达到指定的层数或者NPC在场数量达到指定数量。
 * 区分Level，对于BUFF和技能监控，默认情况下插件不会去区分BUFF的或者技能的等级。在英雄和普通副本中，BOSS释放的BUFF或技能大部分均有等级的区分，对于有特定要求区分的可以勾选区分。


----

## 近期事件记录

插件提供近期记录功能，可以记录周边发生的多数事件，包括NPC喊话在内，所有的近期事件会在数据面板的右侧展示，点击左键或者右键可以使其添加至左边的监控列表。

## 搜索

插件提供强大的搜索功能，普通搜索默认会根据名称或者ID进行匹配，勾选全局搜索后，可以对数据做全面的搜索，小到一个倒计时的名称，大到右边的近期记录技能释放BOSS的名称，都可以完全匹配。

全局搜索例

* 搜搜非玩家的近期记录可以输入`"bIsPlayer":false`，同理过滤BOSS记录可以输入true。
* 搜索谭雪释放的所有技能可以输入`谭雪`。

## 喊话监控

插件的喊话监控支持监听BOSS的喊话以及系统警告框的喊话，并且拥有灵活的自定义功能，例如在喊话对象中输入`%`，喊话内容中输入`$me`，这样就可以监听所有跟自身角色名称有关的喊话。

`特别注意`

* 喊话对象中`%`为通配符，表示不管是谁喊的都监控，留空则表示系统报警框。
* 喊话内容中`$me`代表自己的名字，`$team`代表团队中任意一名成员的名字。
* 喊话监控排序越靠前，优先级越高，所以通配的监控建议移动到最后。

## 提醒模块

插件提醒模块目前拥有以下几个，可以被各类事件自由的调用，未安装的模块不影响插件使用，打钩表示默认已经安装，没打钩表示需要从插件列表中单独安装。

- [x] 倒计时
- [x] 标记系统
- [x] 频道报警
- [x] 中央报警
- [x] 普通效果列表
- [x] 全屏泛光报警
- [x] 推送团队面板
- [x] 特大文字报警
- [ ] 头顶报警
- [ ] 重要效果列表

---

#### 倒计时系统

插件的倒计时模块拥有灵活的可定制度，包括但不限于`图标` `多段倒计时` `重复调用时间限制` 等设置，下面来介绍一个倒计时的基本组成。

一个倒计时，由一个数据所驱动，目前插件支持 `BUFF获得` `BUFF消失` `NPC进入场景` `NPC消失` `NPC全部消失` `NPC进入战斗` `NPC死亡` `NPC全部死亡` `技能开始释放` `技能成功释放` `触发喊话` `NPC血量/内力报警（这个有些特殊）`等多种倒计时触发方式。

一个普通的倒计时（血量/内力报警除外）由 `触发方式` `图标` `团队喊话报警` `倒计时时间` `重复调用时间限制` 所组成。

 * 触发方式：根据数据的类别驱动倒计时的方式各有不同，会在倒计时设置面板提供触发方式的选择与更改。
 * 图标：可以自由更改，制作特色的倒计时。
 * 团队喊话报警：设置面板显示一个“队”字，勾选后倒计时5秒时会在团队中倒数。
 * 倒计时时间：倒计时时间格式分为两种，第一种是普通秒数倒计时；第二种属于分段倒计时，制作格式例如`10,倒计时1;25,倒计时2;55,倒计时3`代表第一个倒计时1结束再触发倒计时2（当前倒计时设置的触发时间-已过时间）15秒的倒计时。后面以此类推，再触发第3个倒计时，并不限制倒计时的数量，可自由填写，常用于BOSS进入战斗后开始的阶段倒计时。
 * 重复调用时间限制：当倒计时所属的数据再次被驱动时，可能会重复触发同样的倒计时导致倒计时被覆盖，这个设置就是解决这个问题，在倒计时最后的小框内直接输入时间即可保证在这段时间内不会再次被重复同样的倒计时，`请注意，分段倒计时默认取最大的时间作为重复调用时间限制，当然您也可以自由更改。`


##### 关于NPC血量/内力报警

这是一个特殊的分类，它的设置格式

例： `0.72,即将进入P2,10;0.3,即将进入P3`

* 当NPC血量/内力为72%时 将触发一个中央报警以及特大文字报警，并且触发10秒倒计时。
* 当NPC血量/内力为30%时 将触发一个中央报警以及特大文字报警。

`特别注意`

* 不支持0.724这样的血量格式。
* NPC血量/内力报警暂时不支持调用分段倒计时。
* NPC血量/内力变化跨度瞬间大于50%时，不适用本功能。
* NPC血量只监控递减，即从高到低才会被监控到。
* NPC内力只监控递增，即从低到高才会被监控到。
* 由于游戏本身限制，内力监控若非当前目标或目标的目标，则存在一定的延迟（1-10s）。

---

#### 标记系统

插件的标记系统支持单选标记或多选标记，基本标记规则如下。

例 勾选 白云 红鼓 棒槌

* 如果是NPC   若npc是当前npc 即给予`白云`标记 若场上同时存在多个相同npc，则根据顺序依次给予`白云、红鼓、棒槌`标记。
* 如果是BUFF  若buff是当前buff 即给予`白云`标记 若场上同时在存在多个玩家拥有相同buff，则根据顺序依次给予`白云、红鼓、棒槌`标记。
* 如果是技能 无条件给标记

---

#### 频道报警

插件的频道报警会根据数据以及应用场景自动生成内容发送到聊天频道，主要用于`团队频道` `私聊频道`。

`特别注意`

* 默认插件关闭了全局的报警，避免团队成员安装多个插件重复发送相同内容，

---

#### 中央报警

插件的频道报警会根据数据以及应用场景自动生成报警内容，带有明显的颜色区别以判断内容的重要性，在屏幕中间弹出红色闪烁框以作为报警提醒。

---

#### 头顶报警

插件的头顶报警可以根据数据内容，在指定的玩家头上增加提示箭头、文字，并且跟随玩家移动而移动。

`特别注意`

* 箭头颜色受`报警通用颜色`影响。

---

#### 普通效果列表

普通效果列表根据插件推送的BUFF，会将其添加到列表中一个单独的BUFF提醒作为提醒，你可以尝试按住Ctrl+右键点击列表中的BUFF来取消可以取消的BUFF。

`特别注意`

* 文字颜色受`报警通用颜色`影响。
* 该提醒`仅提醒自身的BUFF`。

---

#### 重要效果列表

重要效果列表根据插件推送的BUFF，会将其添加到一个单独的重要BUFF列表框作为提醒，点击可以选中目标玩家，一般用于加快治疗需要识别的对象。

---

#### 特大文字报警

特大文字报警会在屏幕中显示一个相当大的文本来提醒数据所推送的内容。

`特别注意`

* 默认情况下，BUFF类仅提醒与自身相关内容。

----

#### 全屏泛光报警

屏幕四周泛光提醒，如果是BUFF类别，会生成一个小边框，当BUFF彻底消失时边框才会消失。

`特别注意`

* 该提醒仅提醒自身相关内容。
* 泛光颜色受`报警通用颜色`影响。

----

#### 推送团队面板

将BUFF推送至指定团队面板以于显示，支持的面板如下。

* 系统团队面板
* Cataclysm团队面板
* RaidGridEx团队面板

`特别注意`

* 部分面板支持背景颜色受`报警通用颜色`影响。
* 若勾选了`仅显示来源自己的BUFF`，那么只有当该效果是受你所触发时才会显示。

----

## 附 高级设置相关

这里的内容主要面向高级玩家，如果觉得看不明白可以忽略。

----

#### 倒计时KEY设置

倒计时key字段：key设置属于高级应用，`一般情况下无须理会`，在现有的倒计时机制无法实现需要的倒计时或想屏蔽重复倒计时的情况下，可以利用此方法来覆盖现有的任意倒计时（仅需倒计时两个KEY相同，插件即认为这两个倒计时属于同一事件所触发，可以彼此覆盖），`按住Ctrl点击倒计时类型下拉框`来打开key设置项，（常用于控制多个重复的倒计时，例如安禄山小怪倒计时，血战天策火箭雨倒计时）。

----

#### 倒计时颜色

倒计时可以设置初始颜色用于区分倒计时的类型和重要程度，您可以参考下表来设置倒计时的`nFrame`字段（需要手动编辑数据文件）。

```
Farme   Left    Top Width   High    File
0   0   0   256 32  C:\Users\Webster\Desktop\计时条\橙色.tga
1   0   34  256 32  C:\Users\Webster\Desktop\计时条\粉色.tga
2   0   68  256 32  C:\Users\Webster\Desktop\计时条\红色.tga
3   0   102 256 32  C:\Users\Webster\Desktop\计时条\黄色.tga
4   0   136 256 32  C:\Users\Webster\Desktop\计时条\灰色.tga
5   0   170 256 32  C:\Users\Webster\Desktop\计时条\蓝色.tga
6   0   204 256 32  C:\Users\Webster\Desktop\计时条\绿色.tga
7   0   238 256 32  C:\Users\Webster\Desktop\计时条\青色.tga
8   0   272 256 32  C:\Users\Webster\Desktop\计时条\紫色.tga
```

----

#### JSON数据整理

由于游戏限制，JSON默认导出的数据会进行转义和增加部分无意义的字符，可以使用以下方法去除。

```php
// 最简单的PHP处理方法
<?php
$content = file_get_contents('data.jx3dat');
$content = trim(substr($content, strpos($content, 'data') + 4));
$content = trim(substr($content, strpos($content, '=') + 1));

$content = stripslashes(trim($content, '"'));
$content = iconv('gbk', 'utf-8//IGNORE', $content);
var_dump(json_decode($content, true));
?>
```

---

#### 插件数据结构与枚举

```lua

-- 数据文件基本结构
data = {
    ["BUFF"] = {
        [dwMapID] = {
            [int index] = {
                [field] = value,
                [DBM_TYPE] = {
                    [field] = value,
                },
                [DBM_TYPE] = {
                    [field] = value,
                },
                -- ...
                [tCountdown] = {
                    [int index] = {
                        [field] = value,
                    }
                }
            }
        }
    },
    -- ...
}

-- 5和10暂时是废弃的，喊话监控使用的是14.
DBM_TYPE = {
    OTHER        = 0,
    BUFF_GET     = 1,
    BUFF_LOSE    = 2,
    NPC_ENTER    = 3,
    NPC_LEAVE    = 4,
    NPC_TALK     = 5,
    NPC_LIFE     = 6,
    NPC_FIGHT    = 7,
    SKILL_BEGIN  = 8,
    SKILL_END    = 9,
    SYS_TALK     = 10,
    NPC_ALLLEAVE = 11,
    NPC_DEATH    = 12,
    NPC_ALLDEATH = 13,
    TALK_MONITOR = 14,
    COMMON       = 15,
}
-- 监控类型不填则为All
DBM_SCRUTINY_TYPE = { SELF  = 1, TEAM  = 2, ENEMY = 3 }
```


----

## 原团队事件监控数据转换DBM数据方法

* 如果您没有自己的数据，无须理会。
* 必要条件：请准备好体验服客户端。
* 打开体服 `interface/JH/DBM/info.ini` 删除里面的`;`，然后登陆客户端。
* 将导出的所有数据文件放到`体服`interface任意文件夹下，如果没有来得及导出数据但是已无团队事件监控插件，可以尝试在询问朋友获取或者看看interface下有无以前可用的副本。
* 然后在聊天框输入 `/ RGESToDBM("szPath")` 请将`szPath`转换为相对路径，例如`/ RGESToDBM("interface/abc.jx3dat")`
* 执行后根据提示找到对应文件，打开DBM面板，导入即可。

